<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblSupervisorCiudadRepository;

final class TblSupervisorCiudadService
{
    private TblSupervisorCiudadRepository $TblSupervisorCiudadRepository;

    public function __construct(TblSupervisorCiudadRepository $TblSupervisorCiudadRepository)
    {
        $this->TblSupervisorCiudadRepository = $TblSupervisorCiudadRepository;
    }

    public function checkAndGet(int $TblSupervisorCiudadId): object
    {
        return $this->TblSupervisorCiudadRepository->checkAndGet($TblSupervisorCiudadId);
    }

    public function getAll(): array
    {
        return $this->TblSupervisorCiudadRepository->getAll();
    }

    public function getOne(int $TblSupervisorCiudadId): object
    {
        return $this->checkAndGet($TblSupervisorCiudadId);
    }

    public function create(array $input): object
    {
        $TblSupervisorCiudad = json_decode((string) json_encode($input), false);

        return $this->TblSupervisorCiudadRepository->create($TblSupervisorCiudad);
    }

    public function update(array $input, int $TblSupervisorCiudadId): object
    {
        $TblSupervisorCiudad = $this->checkAndGet($TblSupervisorCiudadId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblSupervisorCiudadRepository->update($TblSupervisorCiudad, $data);
    }

    public function delete(int $TblSupervisorCiudadId): void
    {
        $this->checkAndGet($TblSupervisorCiudadId);
        $this->TblSupervisorCiudadRepository->delete($TblSupervisorCiudadId);
    }
}
